/*
 *	coretrace - basic debugger for embedded Linux
 *	Copyright (C) 2004 Ronny L Nilsson
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 */



#ifndef MAIN_H
#define MAIN_H



//====== DEFINITIONS =================
enum runmode_t {
	RUNMODE_NONE,												// No reqiested runmode
	RUNMODE_NORMAL,												// backtrace
	RUNMODE_VERSION,
	RUNMODE_USAGE,
	RUNMODE_CRASH												// Do crash, generate core
};


#define MAX_CORE_SIZE		(1024*512)							// Max size of coredumps we wish to generate	


//====== GLOBALS ==================



//====== PROTOTYPES ================
#if defined(DEBUG) && defined(_GNU_SOURCE)
int coreDbg(const char*, const char*, long, const char*, ...)
	__attribute__ ((format (printf, 4, 5)));
#define DBG(text, args...)				\
	coreDbg(__FILE__, __FUNCTION__,	\
	__LINE__, text, ##args)
#else														
#define DBG(text, args...)
#endif


#endif // MAIN_H


